clear all
%Input given data
UAa=5.829;
UAc=10.387;
UAg=4.973;
UAe=12.566;
UAs=1.323;
m11=2.3408;
m13=3.173;
m15=2.5305;
m17=2.3923;
%Input value
%Assume values t10 t8 t4 t5 t1 change with input values
t11=91;
t13=30;
t15=30;
t17=13;
%Constant
a0=0.988;%Licl
a1=0.304;
b0=-27.9;
b1=59.3;
cpv=1.86;%specific heat capacity of vapor
cpw=4.18;%specific heat capacity of water
ms=0.25584;%mass fraction of solution pump
TK=273.15;
%Calculation
t10=6*ones(1,4);%assume t10,,set as last output
tol5=1;
n5=1;
while tol5>0.01
    he=latent_heat(t10(n5));
    t8=38*ones(1,4);%assume t8,,set as last output
    tol4=1;
    n4=1;
    while tol4>0.01
        hc=latent_heat(t8(n4));
        t4=80*ones(1,4);%assume t4,,set as last output
        tol3=1;
        n3=1;
        while tol3>0.01
            T4=t4(n3)+TK;
            T8=t8(n4)+TK;
            x2=(T4-a0*T8-b0)/(a1*T8+b1);%mass fraction of strong solution
            T10=t10(n5)+TK;
            t6a=(a1*x2+a0)*T10+(b1*x2+b0);
            t5=50.6*ones(1,4);%assume t5,,set as last output
            tol2=1;
            n2=1;
            while tol2>0.01
                t45=(t4(n3)+t5(n2))/2;
                cp45=licl_birerong(t45,x2);
                t1=38*ones(1,4);%assume t1,,set as last output
                tol1=1;
                n1=1;
                while tol1>0.01
                    T1=t1(n1)+TK;
                    x1=(T1-a0*T10-b0)/(a1*T10+b1);%mass fraction of weak solution
                    fa=x2/(x2-x1);%circulation ratio
                    mr=ms/fa;%mass fraction of refrigerant
                    t3a=(a1*x1+a0)*T8+(b1*x1+b0);
                    ag=((T4+t3a)/2/T8)^2/(a1*(x1+x2)/2+a0);
                    aa=((t6a+T1)/T10/2)^2/(a1*(x1+x2)/2+a0);
                    %Absorber
                    t51=(t5(n2)+t1(n1))/2;
                    t56=(t5(n2)+t6a-TK)/2;
                    cp1=licl_birerong(t51,x1);
                    cp3=licl_birerong(t56,x2);
                    Qa=ms*cp1*(t5(n2)-t1(n1))+mr*(aa*he+cpv*(t10(n5)-t1(n1))-cp3*(t5(n2)-t6a+TK));
                    t14=Qa/(m13*cpw)+t13;
                    A=(Qa/UAa)^3;
                    f1=@(y1)(t5(n2)-t14)*(y1-t13)*((t5(n2)-t14)+(y1-t13))/2-A;
                    t1(n1+1)=fzero(f1,36);
                    n1=n1+1;
                    if n1==3
                        t1(4)=(t1(1)*t1(3)-t1(2)^2)/(t1(3)-2*t1(2)+t1(1));
                        tol1=abs(t1(4)-t1(1));
                        t1(1)=t1(4);
                        n1=1;
                    end
                end
                tt1=t1(4);%t1ֵ
                %Solution heat exchanger
                Qs=(fa-1)*mr*(t4(n3)-t5(n2))*cp45;
                cp23=licl_birerong(tt1,x1);
                t3=Qs/ms/cp23+tt1;
                tol6=1;
          while tol6>0.01
                t23=(t3+tt1)/2;
                cp23=licl_birerong(t23,x1);
                tt3=Qs/ms/cp23+tt1;
                tol6=abs(tt3-t3);
                t3=tt3;
           end
                B=(Qs/UAs)^3;
                f2=@(y2)(t4(n3)-t3)*(y2-tt1)*((t4(n3)-t3)+(y2-tt1))/2-B;
                t5(n2+1)=fzero(f2,50);
                n2=n2+1;
                if n2==3
                    t5(4)=(t5(1)*t5(3)-t5(2)^2)/(t5(3)-2*t5(2)+t5(1));
                    tol2=abs(t5(4)-t5(1));
                    t5(1)=t5(4);
                    n2=1;
                end
            end
                    tt5=t5(4);
                    %Generator
                    t43=(t4(n3)+t3)/2;
                    cp2=licl_birerong(t43,x1);
                    Qg=ms*cp2*(t4(n3)-t3)+mr*ag*hc;
                    t12=t11-Qg/(m11*cpw);
                    C=(Qg/UAg)^3;
                    f3=@(y3)(t12-t3)*(t11-y3)*((t12-t3)+(t11-y3))/2-C;
                    t4(n3+1)=fzero(f3,80);
                    n3=n3+1;
                    if n3==3
                        t4(4)=(t4(1)*t4(3)-t4(2)^2)/(t4(3)-2*t4(2)+t4(1));
                        tol3=abs(t4(4)-t4(1));
                        t4(1)=t4(4);
                        n3=1;
                    end
        end
        tt4=t4(4);
        %Condenser
        Qc=mr*(hc+cpv*(tt4-t8(n4)));
        t16=t15+Qc/(m15*cpw);
        D=(Qc/UAc)^3;
        f4=@(y4)(y4-t15)*(y4-t16)*((y4-t15)+(y4-t16))/2-D;
        t8(n4+1)=fzero(f4,38);
        n4=n4+1;
        if n4==3
            t8(4)=(t8(1)*t8(3)-t8(2)^2)/(t8(3)-2*t8(2)+t8(1));
            tol4=abs(t8(4)-t8(1));
            t8(1)=t8(4);
            n4=1;
        end
    end
    tt8=t8(4);
    %Evaporator
    Qe=mr*(he-cpw*(tt8-t10(n5)));
    t18=t17-Qe/(m17*cpw);
    E=(Qe/UAe)^3;
    f5=@(y5)(t17-y5)*(t18-y5)*((t17-y5)+(t18-y5))/2-E;
    t10(n5+1)=fzero(f5,6);
    n5=n5+1;
    if n5==3
        t10(4)=(t10(1)*t10(3)-t10(2)^2)/(t10(3)-2*t10(2)+t10(1));
        tol5=abs(t10(4)-t10(1));
        t10(1)=t10(4);
        n5=1;
    end
end
tt10=t10(4);
tt2=tt1;
tt6=tt5;
tt7=tt4;
tt9=tt10;
cop=Qe/Qg;
%Output
F=[Qg;Qa;Qc;Qe;Qs;cop]; 
G=[tt1;tt2;t3;tt4;tt5;tt6;tt7;tt8;tt9;tt10];
H=[t12;t14;t16;t18];